package com.zz.common.mybatis.generator.plugin;

import static org.mybatis.generator.internal.util.StringUtility.stringHasValue;

import java.util.ArrayList;
import java.util.List;

import org.mybatis.generator.api.IntrospectedColumn;
import org.mybatis.generator.api.IntrospectedTable;
import org.mybatis.generator.api.PluginAdapter;
import org.mybatis.generator.api.dom.java.FullyQualifiedJavaType;
import org.mybatis.generator.api.dom.java.Interface;
import org.mybatis.generator.api.dom.java.Method;
import org.mybatis.generator.api.dom.java.TopLevelClass;
import org.mybatis.generator.api.dom.xml.Attribute;
import org.mybatis.generator.api.dom.xml.Document;
import org.mybatis.generator.api.dom.xml.TextElement;
import org.mybatis.generator.api.dom.xml.XmlElement;
import org.mybatis.generator.codegen.mybatis3.MyBatis3FormattingUtilities;

/**
 * 
 * @author wangzhengzhen
 *
 */
public class CommonPagingPlugin extends PluginAdapter {

	/**
	 * {@inheritDoc}
	 */
	@Override
	public boolean clientSelectByExampleWithoutBLOBsMethodGenerated(Method method, Interface interfaze,
			IntrospectedTable introspectedTable) {

//		interfaze.addImportedType(new FullyQualifiedJavaType("java.util.List"));
//		interfaze.addImportedType(new FullyQualifiedJavaType("com.zz.framework.dao.IPagingDao"));
//		interfaze.addImportedType(new FullyQualifiedJavaType("com.zz.framework.model.SortModel"));
//		interfaze.addImportedType(new FullyQualifiedJavaType("com.zz.framework.model.PagingModel"));
		
		interfaze.addSuperInterface(new FullyQualifiedJavaType("com.zz.framework.dao.IPagingDao"));
		
//		interfaze.addMethod(generatePagingLogic(method, introspectedTable));
		
		return true;
	}

	/**
	 * {@inheritDoc}
	 */
	@Override
	public boolean clientSelectByPrimaryKeyMethodGenerated(Method method, Interface interfaze,
			IntrospectedTable introspectedTable) {

//		interfaze.addImportedType(new FullyQualifiedJavaType("java.util.List"));
//		interfaze.addImportedType(new FullyQualifiedJavaType("com.zz.framework.dao.IPagingDao"));
//		interfaze.addImportedType(new FullyQualifiedJavaType("com.zz.framework.model.SortModel"));
//		interfaze.addImportedType(new FullyQualifiedJavaType("com.zz.framework.model.PagingModel"));
		
		interfaze.addSuperInterface(new FullyQualifiedJavaType("com.zz.framework.dao.IPagingDao"));
		
//		interfaze.addMethod(generatePagingLogic(method, introspectedTable));
		
		return true;
	}

	/**
	 * {@inheritDoc}
	 */
	@Override
	public boolean clientSelectByPrimaryKeyMethodGenerated(Method method, TopLevelClass topLevelClass,
			IntrospectedTable introspectedTable) {

//		topLevelClass.addImportedType(new FullyQualifiedJavaType("java.util.List"));
//		topLevelClass.addImportedType(new FullyQualifiedJavaType("com.zz.framework.dao.IPagingDao"));
//		topLevelClass.addImportedType(new FullyQualifiedJavaType("com.zz.framework.model.SortModel"));
//		topLevelClass.addImportedType(new FullyQualifiedJavaType("com.zz.framework.model.PagingModel"));
		
		topLevelClass.addSuperInterface(new FullyQualifiedJavaType("com.zz.framework.dao.IPagingDao"));
		
//		topLevelClass.addMethod(generatePagingLogic(method, introspectedTable));
		
		return true;
	}
	
	@Override
	public boolean sqlMapDocumentGenerated(Document document, IntrospectedTable introspectedTable) {

		String tableName = introspectedTable.getAliasedFullyQualifiedTableNameAtRuntime();// 数据库表名

//		String parameterType = null;
//		if (introspectedTable.getRules().generatePrimaryKeyClass()) {
//			parameterType = introspectedTable.getPrimaryKeyType();
//		} else {
			// select by primary key, but no primary key class. Fields
			// must be in the base record
//			parameterType = introspectedTable.getBaseRecordType();
//		}
		
		XmlElement parentElement = document.getRootElement();
		
		// 分页
		XmlElement pagingLogicElement = new XmlElement("select");
		pagingLogicElement.addAttribute(new Attribute("id", "query"));
		
		if (introspectedTable.getRules().generateResultMapWithBLOBs()) {
			pagingLogicElement.addAttribute(new Attribute("resultMap", //$NON-NLS-1$
                    introspectedTable.getResultMapWithBLOBsId()));
        } else {
        	pagingLogicElement.addAttribute(new Attribute("resultMap", //$NON-NLS-1$
                    introspectedTable.getBaseResultMapId()));
        }
        
        context.getCommentGenerator().addComment(pagingLogicElement);
        
        // 计算总数
        XmlElement countLogicElement = new XmlElement("select");
		countLogicElement.addAttribute(new Attribute("id", "queryCount"));
//		countLogicElement.addAttribute(new Attribute("parameterType", //$NON-NLS-1$
//					parameterType));
		countLogicElement.addAttribute(new Attribute("resultType", //$NON-NLS-1$
              "java.lang.Long"));
		countLogicElement.addElement(new TextElement("select count(id) from " + tableName));
		
        context.getCommentGenerator().addComment(countLogicElement);
		
        StringBuilder sb = new StringBuilder();
        sb.append("select "); //$NON-NLS-1$

        if (stringHasValue(introspectedTable.getSelectByPrimaryKeyQueryId())) {
            sb.append('\'');
            sb.append(introspectedTable.getSelectByPrimaryKeyQueryId());
            sb.append("' as QUERYID,"); //$NON-NLS-1$
        }
        pagingLogicElement.addElement(new TextElement(sb.toString()));
        pagingLogicElement.addElement(getBaseColumnListElement(introspectedTable));
        if (introspectedTable.hasBLOBColumns()) {
        	pagingLogicElement.addElement(new TextElement(",")); //$NON-NLS-1$
        	pagingLogicElement.addElement(getBlobColumnListElement(introspectedTable));
        }
        
        sb.setLength(0);
        sb.append("from "); //$NON-NLS-1$
        sb.append(tableName);
        pagingLogicElement.addElement(new TextElement(sb.toString()));

        XmlElement condition = new XmlElement("if");
        condition.addAttribute(new Attribute("test", "condition != null")); //$NON-NLS-1$
        
        XmlElement dynamicElement = new XmlElement("trim");
        dynamicElement.addAttribute(new Attribute("prefix", "where 1=1 "));
        
        List<IntrospectedColumn> columnList = new ArrayList<IntrospectedColumn>();
        columnList.addAll(introspectedTable.getPrimaryKeyColumns());
        columnList.addAll(introspectedTable.getBaseColumns());
        for (IntrospectedColumn introspectedColumn : columnList) {
            sb.setLength(0);
            sb.append("condition." + introspectedColumn.getJavaProperty());
        	sb.append(" != null"); //$NON-NLS-1$
        	XmlElement isNotNullElement = new XmlElement("if");
        	isNotNullElement.addAttribute(new Attribute("test", sb.toString())); //$NON-NLS-1$
        	
        	sb.setLength(0);
            sb.append("  and "); //$NON-NLS-1$

            sb.append(MyBatis3FormattingUtilities
                    .getAliasedEscapedColumnName(introspectedColumn));
            sb.append(" = "); //$NON-NLS-1$
            sb.append(MyBatis3FormattingUtilities
                    .getParameterClause(introspectedColumn, "condition."));
            
            isNotNullElement.addElement(new TextElement(sb.toString()));
            dynamicElement.addElement(isNotNullElement);
        }
        
        XmlElement date = new XmlElement("if");
        date.addAttribute(new Attribute("test", "date != null and date.column != null"));
        XmlElement startDateIsNotNullElement = new XmlElement("if");
        startDateIsNotNullElement.addAttribute(new Attribute("test", "date.startDate != null"));
        startDateIsNotNullElement.addElement(new TextElement("and ${date.column} &gt;= #{date.startDate}"));
        date.addElement(startDateIsNotNullElement);
        XmlElement endDateIsNotNullElement = new XmlElement("if");
        endDateIsNotNullElement.addAttribute(new Attribute("test", "date.endDate != null"));
        endDateIsNotNullElement.addElement(new TextElement("and ${date.column} &lt;= #{date.endDate}"));
        date.addElement(endDateIsNotNullElement);
        dynamicElement.addElement(date);
        
        XmlElement countDynamicElement = new XmlElement(dynamicElement);
        countLogicElement.addElement(countDynamicElement);
        
        condition.addElement(dynamicElement);
        pagingLogicElement.addElement(condition);
        
        XmlElement orderBy = new XmlElement("if");
        orderBy.addAttribute(new Attribute("test", "sort != null and sort.column != null")); //$NON-NLS-1$
        orderBy.addElement(new TextElement(" order by ${sort.column} ${sort.method}"));
//        XmlElement asc = new XmlElement("if");
//        asc.addAttribute(new Attribute("test", "sort.method == 'ASC'"));
//        asc.addElement(new TextElement(" order by ${sort.column} ASC"));
//        orderBy.addElement(asc);
//        XmlElement desc = new XmlElement("if");
//        desc.addAttribute(new Attribute("test", "sort.method == 'DESC'"));
//        desc.addElement(new TextElement(" order by ${sort.column} DESC"));
//        orderBy.addElement(desc);
        pagingLogicElement.addElement(orderBy);
        
        XmlElement paging = new XmlElement("if");
        paging.addAttribute(new Attribute("test", "paging != null")); //$NON-NLS-1$
        paging.addElement(new TextElement(" limit #{paging.start}, #{paging.row}"));
        pagingLogicElement.addElement(paging);
        
        if (context.getPlugins().sqlMapSelectByPrimaryKeyElementGenerated(pagingLogicElement, introspectedTable)) {
            parentElement.addElement(pagingLogicElement);
        }
        if (context.getPlugins().sqlMapSelectByPrimaryKeyElementGenerated(countLogicElement, introspectedTable)) {
            parentElement.addElement(countLogicElement);
        }

		return super.sqlMapDocumentGenerated(document, introspectedTable);
	}

	public boolean validate(List<String> arg0) {

		return true;
	}

//	private Method generatePagingLogic(Method method, IntrospectedTable introspectedTable) {
//
//		Method m = new Method("query");
//
//		m.setVisibility(method.getVisibility());
//
//		m.setReturnType(new FullyQualifiedJavaType("List<?>"));
//
//		m.addParameter(new Parameter(new FullyQualifiedJavaType("Object"), "condition", "@Param(\"condition\")"));
//		m.addParameter(new Parameter(new FullyQualifiedJavaType("SortModel"), "sort", "@Param(\"sort\")"));
//		m.addParameter(new Parameter(new FullyQualifiedJavaType("PagingModel"), "paging", "@Param(\"paging\")"));
//		
//		context.getCommentGenerator().addGeneralMethodComment(m, introspectedTable);
//		
//		return m;
//	}

	protected XmlElement getBaseColumnListElement(IntrospectedTable introspectedTable) {
        XmlElement answer = new XmlElement("include"); //$NON-NLS-1$
        answer.addAttribute(new Attribute("refid", //$NON-NLS-1$
                introspectedTable.getMyBatis3SqlMapNamespace()
                        + "." + introspectedTable.getBaseColumnListId())); //$NON-NLS-1$
        return answer;
    }

    protected XmlElement getBlobColumnListElement(IntrospectedTable introspectedTable) {
        XmlElement answer = new XmlElement("include"); //$NON-NLS-1$
        answer.addAttribute(new Attribute("refid", //$NON-NLS-1$
                introspectedTable.getMyBatis3SqlMapNamespace()
                        + "." + introspectedTable.getBlobColumnListId())); //$NON-NLS-1$
        return answer;
    }
}
