package com.zz.framework.model;

import java.io.Serializable;
import java.util.List;

/**
 * 
 * @author zhengzhen.wang
 *
 */
public class PagingModel implements Serializable {

	/**
	 * 
	 */
	private static final long serialVersionUID = 1L;

	// 当前页码
	private int current = 1;
	// 每行显示数据条数
	private int row;
	// 总页数
	private int total;
	// 数据记录数
	private long count;
	// 当页的数据对象
	private List<?> data;
	// 起始位置
	private int start;
	// 结束位置
	private int end;

	public PagingModel() {
		row = 10;
	}

	public PagingModel(int row) {
		this.row = row;
	}

	public int getCurrent() {
		return current;
	}

	public void setCurrent(int current) {
		this.current = current;
		this.start = (current - 1) * row;
		this.end = start + row;
	}

	public int getRow() {
		return row;
	}
	
	public void setRow(int row) {
		this.row = row;
	}

	public int getTotal() {
		return total;
	}

	public void setTotal(int total) {
		this.total = total;
	}

	public long getCount() {
		return count;
	}

	public void setCount(long count) {
		this.count = count;
		// 计算页数
		this.total = (int) ((count + row - 1) / row);
	}

	public List<?> getData() {
		return data;
	}

	public void setData(List<?> data) {
		this.data = data;
	}

	public int getStart() {
		return start;
	}

	public void setStart(int start) {
		this.start = start;
	}

	public int getEnd() {
		return end;
	}

	public void setEnd(int end) {
		this.end = end;
	}

}
